
uses Objects;

type
 PFont = ^TFont;
 TFont = object(TObject)
  Width  : byte;
  Height : byte;
  Font   : pointer;
  Block  : byte;
  constructor Init(FileName : string; ABlock:byte);
  destructor  Done; virtual;
  procedure   SetSecond(AsAtribute : boolean);
 private
  procedure   LoadFont;
 end;

var
 FirstFont  : PFont;
 SecondFont : PFont;

{----------------------------------------------------------------------------}

constructor TFont.Init(FileName : string; ABlock:byte);

 var LastError : integer;

 procedure ErrorHandler(Res : integer);
  var
   P : array [0..0] of Longint;
  begin
   P[0]:=Res;
   if P[0]<>0 then
{
    if Application<>nil
     then  MessageBox(^C'I/O Error %d',@P,mfOkButton or mfError)
     else
}
    Writeln('I/O Error ',Res);
   LastError:=Res;
  end;

 var
  F : file;
  S : Longint;
  N : word;
  begin
{$I-}
   Assign(F,FileName);
   Reset(F,1);
   ErrorHandler(IOResult);
   if LastError<>0 then Fail;
   S:=FileSize(F);
   ErrorHandler(IOResult);
   if LastError<>0 then Fail;
   Width:=8;
   Height:=S div 256;
   if LastError=0 then GetMem(Font,S);
   if Font<>nil then BlockRead(F,Font^,S,N);
   ErrorHandler(IOResult);
   if LastError<>0 then Fail;
   Close(f);
   ErrorHandler(IOResult);
{$I+}
   Block:=ABlock;
   LoadFont;
  end;

procedure TFont.SetSecond(AsAtribute : boolean);assembler;
 { set block specification; bl=..yxyyxx                   }
 { xxx - first font block number  (displayed if bit 3 =0) }
 { yyy - second font block number (displayed if bit 3 =1) }
 asm
       cmp     AsAtribute,0
       je      @@1
       mov     ax,1000h
       mov     bx,0712h    { enable ATR bit 3-bright for choose  }
       int     10h
@@1:
       mov     ax,1103h
       mov     bl,04h      { choose block 0,1 (as comment on top)}
       int     10h

 end;

procedure TFont.LoadFont;assembler;
 asm
       push    ds
       lds     si,self
       les     di,ds:[si].TFont.Font
       push    bp
       mov     bp,di
       mov     bl,ds:[si].TFont.Block
       mov     bh,ds:[si].TFont.Height
       mov     cx,0100h
       mov     dx,0
       mov     ax,1100h
       int     10h
       pop     bp
       pop     ds
 end;

destructor TFont.Done;
 begin
  if Font<>nil then FreeMem(Font,Height*256);
 end;

{----------------------------------------------------------------------------}
begin
 if ParamCount<1 then Halt(1);

 asm
  mov   ax,0003h
  int   10h
 end;

 New(FirstFont,Init(ParamStr(1),0));
 if ParamCount > 1 then
  begin
   New(SecondFont,Init(ParamStr(2),1));
   FirstFont^.SetSecond(false);
  end;

 if FirstFont<>nil then Dispose(FirstFont,Done);
 if SecondFont<>nil then Dispose(SecondFont,Done);
end.

